src/TestYourSkills.Web/Areas/Admin/Controllers/TopicController.cs
using AutoMapper;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using TestYourSkills.Core.Interfaces;
using TestYourSkills.Core.Models.Questions;
using TestYourSkills.Core.ViewModels;

namespace TestYourSkills.Web.Areas.Admin.Controllers;

[Area("Admin")]
[Authorize(Roles = "Admin,Redactor")]
public class TopicController : Controller
{
    private readonly IMapper _mapper;
    private readonly IQuestionService _questionService;

    public TopicController(IMapper mapper, IQuestionService questionService)
    {
        _mapper = mapper;
        _questionService = questionService;
    }

    [HttpGet]
    public async Task<IActionResult> Index()
    {
        var topics = await _questionService.GetTopicsAsync();
        var topicVm = _mapper.Map<IEnumerable<TopicViewModel>>(topics);

        return View(topicVm);
    }

    [HttpGet]
    public IActionResult AddTopic()
    {
        return View();
    }

    [HttpPost]
    public async Task<IActionResult> AddTopic(AddTopicViewModel model)
    {
        if (ModelState.IsValid)
        {
            try
            {
                var topic = _mapper.Map<Topic>(model);
                var newTopic = await _questionService.AddTopicAsync(topic);
                if (topic != null)
                    return RedirectToAction(nameof(Index));
            }
            catch (Exception exc)
            {
                ModelState.AddModelError("", exc.InnerException != null ? exc.InnerException?.Message! : exc.Message);
            }
        }

        return View();
    }

    public async Task<IActionResult> UpdateTopic(int id, string name)
    {
        UpdateTopicViewModel topicVm = new() { Id = id, Name = name };

        try
        {
            var topic = await _questionService.GetQuestionsForTopicAsync(id);
            topicVm.Questions = _mapper.Map<IEnumerable<UpdateTopicQuestionViewModel>>(topic);
        }
        catch (Exception exc)
        {
            ModelState.AddModelError("", exc.InnerException != null ? exc.InnerException?.Message! : exc.Message);
        }

        return View(topicVm);
    }

    [HttpPost]
    public async Task<IActionResult> UpdateTopic(AddTopicViewModel model)
    {
        if (ModelState.IsValid)
        {
            try
            {
                var topic = _mapper.Map<Topic>(model);
                var updatedTopic = await _questionService.UpdateTopicAsync(topic);
                if (topic != null)
                    return View();
            }
            catch (Exception exc)
            {
                ModelState.AddModelError("", exc.InnerException != null ? exc.InnerException?.Message! : exc.Message);
            }
        }

        return View();
    }

    [HttpPost]
    public async Task<IActionResult> UpdateTopicTitle(UpdateTopicTitleViewModel model)
    {
        if (ModelState.IsValid)
        {
            try
            {
                var topic = _mapper.Map<Topic>(model);
                var updatedTopic = await _questionService.UpdateTopicAsync(topic);
            }
            catch (Exception exc)
            {
                ModelState.AddModelError("", exc.InnerException != null ? exc.InnerException?.Message! : exc.Message);
            }
        }

        return RedirectToAction(nameof(UpdateTopic),
            new { id = model.Id, name = model.Name });
    }

    public async Task<IActionResult> DeleteTopic(int id)
    {
        try
        {
            var deleted = await _questionService.RemoveTopicAsync(id);
            if (!deleted)
                ModelState.AddModelError("", "Topic not deleted");
        }
        catch (Exception exc)
        {
            ModelState.AddModelError("", exc.InnerException != null ? exc.InnerException?.Message! : exc.Message);
        }

        return RedirectToAction(nameof(Index));
    }

    [HttpGet]
    public async Task<IActionResult> AddQuestion(int topicId, string topicName)
    {
        AddTopicQuestionViewModel questionVm = new() { TopicId = topicId, TopicName = topicName };
        return View(questionVm);
    }

    [HttpPost]
    public async Task<IActionResult> AddQuestion(AddTopicQuestionViewModel model)
    {
        AddTopicQuestionViewModel topicVm = new();

        try
        {
            var topicQuestion = _mapper.Map<Question>(model);
            var added = await _questionService.AddQuestionsAsync(new List<Question>() { topicQuestion });

            return RedirectToAction(nameof(UpdateTopic), new { id = model.TopicId, name = model.TopicName });
        }
        catch (Exception exc)
        {
            if (exc.InnerException != null)
                ModelState.AddModelError("", exc.InnerException?.Message!);
            else
                ModelState.AddModelError("", exc.Message);
        }

        return View(topicVm);
    }

    [HttpGet]
    public async Task<IActionResult> UpdateQuestion(int topicId, string topicName, int questionId)
    {
        var questions = await _questionService.GetQuestionsForTopicAsync(topicId);
        var question = questions.Where(q => q.Id == questionId).First();
        var questionVm = _mapper.Map<UpdateTopicQuestionViewModel>(question);
        questionVm.TopicName = topicName;
        return View(questionVm);
    }

    [HttpPost]
    public async Task<IActionResult> UpdateQuestion(UpdateTopicQuestionViewModel model)
    {
        UpdateTopicQuestionViewModel topicVm = new();
        try
        {
            var topicQuestion = _mapper.Map<Question>(model);
            var question = await _questionService.GetQuestionAsync(model.Id);
            List<int> idsForRemove = new();
            foreach (var qa in question.QuestionAnswers)
            {
                var questionForUpdate = model.QuestionAnswers!.FirstOrDefault(q => q.Id == qa.Id);
                if (questionForUpdate == null)
                    idsForRemove.Add(qa.Id);
                else
                {
                    qa.CorrectAnswer = questionForUpdate.CorrectAnswer;
                    qa.Message = questionForUpdate.Message;
                }
            }

            foreach (var id in idsForRemove)
                await _questionService.RemoveQuestionAnswerAsync(id);

            await _questionService.AddQuestionAnswersAsync(topicQuestion.QuestionAnswers!
                .Where(q => q.Id == 0)
                .Select(qa => new QuestionAnswer
                    { QuestionId = question.Id, CorrectAnswer = qa.CorrectAnswer, Message = qa.Message }));

            question.Title = topicQuestion.Title;
            question.Details = topicQuestion.Details;
            question.MultiAnswers = topicQuestion.MultiAnswers;

            var updated = await _questionService.UpdateQuestionAsync(question);
            return RedirectToAction(nameof(UpdateTopic), new { id = model.TopicId, name = model.TopicName });
        }
        catch (Exception exc)
        {
            if (exc.InnerException != null)
                ModelState.AddModelError("", exc.InnerException?.Message!);
            else
                ModelState.AddModelError("", exc.Message);
        }

        return View(topicVm);
    }


    public IActionResult AddQuestionPartial(string answerId, bool isUpdate)
    {
        BaseTopicQuestionAnswerViewModel answerViewModel = isUpdate
            ? new UpdateTopicQuestionAnswerViewModel()
            : new AddTopicQuestionAnswerViewModel();
        ViewBag.AnswerId = answerId; // Pass the answerId to the partial view
        return PartialView("_QuestionAnswerPartial", answerViewModel);
    }

    public async Task<IActionResult> DeleteQuestion(int topicId, string topicName, int questionId)
    {
        try
        {
            var question = await _questionService.GetQuestionAsync(questionId);
            foreach (var questionAnswerId in question.QuestionAnswers.Select(qa => qa.Id).ToList())
                await _questionService.RemoveQuestionAnswerAsync(questionAnswerId);

            var deleted = await _questionService.RemoveQuestionAsync(questionId);
            if (!deleted)
                ModelState.AddModelError("", "Question not deleted");
        }
        catch (Exception exc)
        {
            ModelState.AddModelError("", exc.InnerException?.Message!);
        }

        return RedirectToAction(nameof(UpdateTopic), new { id = topicId, name = topicName });
    }
}

src/TestYourSkills.Web/Areas/Admin/Views/Topic/AddQuestion.cshtml
@model AddTopicQuestionViewModel

<link rel="stylesheet" href="/css/topics/topic.css" xmlns="http://www.w3.org/1999/html"/>

<div class="card-text shadow border-0 mt-4">
    <div class="card-header bg-primary">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">@Model.TopicName</h2>
            </div>
        </div>
    </div>
    <div class="card-body p-3">
        <form asp-action="AddQuestion" method="post">
            <input asp-for="TopicId" hidden/>
            <input asp-for="TopicName" hidden/>

            <div class="row pt-2">
                <div class="col-md-12">
                    <h3 class="border-bottom pb-3 mb-4 text-primary text-center">Create Question</h3>
                    <div asp-validation-summary="ModelOnly" class="text-danger" role="alert"></div>
                    <div class="form-floating mb-3">
                        <input asp-for="Title" class="form-control" autocomplete="question-name" placeholder="question name" aria-required="true"/>
                        <label class="ms-2">Question Name</label>
                        <span asp-validation-for="Title" class="text-danger"></span>
                    </div>
                    <div class="form-floating mb-3">
                        <div class="row mx-2">
                            <div class="form-check col-md-6">
                                <label class="radio-button">
                                    <input asp-for="MultiAnswers" class="form-check-input" type="radio" id="optionsRadios1" value="false">
                                    <label class="form-check-label" for="optionsRadios1">
                                        Only 1 answer
                                    </label>
                                    <span class="checkmark"></span>
                                </label>
                            </div>
                            <div class="form-check col-md-6">
                                <label class="radio-button">
                                    <input asp-for="MultiAnswers" class="form-check-input" type="radio" id="optionsRadios2" value="true">
                                    <label class="form-check-label" for="optionsRadios1">
                                        More then 1 answer
                                    </label>
                                    <span class="checkmark"></span>
                                </label>
                            </div>
                        </div>
                    </div>

                    <label class="ms-2">Details</label>
                    <textarea asp-for="Details" class="form-control" rows="3"></textarea>
                    
                    <h4 class="divider-text d-flex py-3">Answers</h4>
                    <button type="button" class="btn btn-primary col-md-4 offset-md-4" id="add-answer-button">
                        <i class="bi bi-plus-lg"></i>
                        Answer
                    </button>

                    <div class="row my-3">
                        <!-- Question Answers container -->
                        <div id="question-answers-container">
                            @if (Model.QuestionAnswers != null)
                            {
                                foreach (var answer in Model.QuestionAnswers)
                                {
                                    @(await Html.PartialAsync("_QuestionAnswerPartial", answer))
                                }
                            }
                        </div>

                    </div>

                    <button type="submit" class="btn btn-primary col-md-4 offset-md-4 mb-3">Create Question</button>
                </div>
            </div>
        </form>
    </div>
</div>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

<!-- JavaScript/jQuery code -->
<script>
    $(document).ready(function () {
        var counter = 0;

        // Add Answer button click event
        $("#add-answer-button").on("click", function () {
            // Generate a unique ID for the new answer
            var answerId = "answer_" + counter++;

            // Load the partial view into the container
            $.get("/Admin/Topic/AddQuestionPartial", { answerId: answerId, isUpdate: false }, function (response) {
                $("#question-answers-container").append(response);
            });
        });
    });
</script>

src/TestYourSkills.Web/Areas/Admin/Views/Topic/AddTopic.cshtml
@model AddTopicViewModel

<div class="card-text shadow border-0 mt-4">
    <div class="card-header bg-primary ml-0 p-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">Add Topic</h2>
            </div>
        </div>
    </div>
    <div class="card-body p-3">
        <form asp-action="AddTopic" method="post">
            <div class="form-floating mb-3">
                <input asp-for="TopicName" class="form-control" placeholder="Topic Name" />
                <span asp-validation-for="TopicName" class="text-danger"></span>
                <label asp-for="TopicName">Topic Name</label>
            </div>

            <button class="btn btn-primary col-md-6 offset-md-3 py-2">Add Topic</button>
        </form>
    </div>
</div>

src/TestYourSkills.Web/Areas/Admin/Views/Topic/Index.cshtml
@model IEnumerable<TopicViewModel>

<div class="card-text shadow border-0 mt-4">
    <div class="card-header bg-primary ml-0 p-3">
        <div class="row">
            <div class="col-6 text-end">
                <h2 class="text-white py-2">Topic List</h2>
            </div>
            <div class="col-6 mt-3 text-end">
                <a asp-controller="Topic" asp-action="AddTopic" class="btn btn-secondary"><i class="bi bi-plus-lg"></i> New Topic</a>
            </div>
        </div>
    </div>
    <div class="card-body p-3">
        <table id="tblData" class="table table-hover" style="width:100%">
            <thead>
                <tr>
                    <th>@Html.DisplayNameFor(model => model.Name)</th>
                    <th>Count</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>

                @foreach (var topic in @Model)
                {
                    <tr>
                        <td>@Html.DisplayFor(modelItem => topic.Name)</td>
                        <td>@topic.QuestionsCount</td>
                        <td class="text-end">
                            <a asp-controller="Topic" asp-action="UpdateTopic" asp-route-id="@topic.Id" asp-route-name="@topic.Name" title="Update" class="btn btn-primary">
                                <i class="bi bi-pencil-square"></i>
                            </a>
                            <a asp-controller="Topic" asp-action="DeleteTopic" asp-route-id="@topic.Id" title="Delete" class="btn btn-primary">
                                <i class="bi bi-trash-fill"></i>
                            </a>
                        </td>
                    </tr>
                }
            </tbody>
        </table>

    </div>
</div>

@section Scripts{
    <script src="~/js/section.js"></script>
}

src/TestYourSkills.Web/Areas/Admin/Views/Topic/UpdateQuestion.cshtml
@model UpdateTopicQuestionViewModel

<link rel="stylesheet" href="/css/topics/topic.css" xmlns="http://www.w3.org/1999/html"/>

<div class="card-text shadow border-0 mt-4">
    <div class="card-header bg-primary">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">@Model.TopicName</h2>
            </div>
        </div>
    </div>
    <div class="card-body p-3">
        <form asp-action="UpdateQuestion" method="post">
            <input asp-for="TopicId" hidden/>
            <input asp-for="Id" hidden />

            <div class="row pt-2">
                <div class="col-md-12">
                    <h3 class="border-bottom pb-3 mb-4 text-primary text-center">Update Question</h3>
                    <div asp-validation-summary="ModelOnly" class="text-danger" role="alert"></div>
                    <div class="form-floating mb-3">
                        <input asp-for="Title" class="form-control" autocomplete="question-name" placeholder="question name" aria-required="true" />
                        <label class="ms-2">@Model.Title</label>
                        <span asp-validation-for="Title" class="text-danger"></span>
                    </div>
                    <div class="form-floating mb-3">
                        <div class="row mx-2">
                            <div class="form-check col-md-6">
                                <label class="radio-button">
                                    <input asp-for="MultiAnswers" class="form-check-input" type="radio" id="optionsRadios1" value="false">
                                    <label class="form-check-label" for="optionsRadios1">
                                        Only 1 answer
                                    </label>
                                    <span class="checkmark"></span>
                                </label>
                            </div>
                            <div class="form-check col-md-6">
                                <label class="radio-button">
                                    <input asp-for="MultiAnswers" class="form-check-input" type="radio" id="optionsRadios2" value="true">
                                    <label class="form-check-label" for="optionsRadios1">
                                        More then 1 answer
                                    </label>
                                    <span class="checkmark"></span>
                                </label>
                            </div>
                        </div>
                    </div>

                    <label class="ms-2">Details</label>
                    <textarea asp-for="Details" class="form-control" rows="3"></textarea>
                    
                    <h4 class="divider-text d-flex py-3">Answers</h4>
                    <button type="button" class="btn btn-primary col-md-4 offset-md-4" id="add-answer-button">
                        <i class="bi bi-plus-lg"></i>
                        Answer
                    </button>

                    <div class="row my-3">
                        <!-- Question Answers container -->
                        <div id="question-answers-container">
                            @if (Model.QuestionAnswers != null)
                            {
                                int counter = 100;
                                foreach (var answer in Model.QuestionAnswers)
                                {
                                    ViewBag.AnswerId = "answer_" + counter++;
                                    @(await Html.PartialAsync("_QuestionAnswerPartial", answer))
                                }
                            }
                        </div>

                    </div>

                    <button type="submit" class="btn btn-primary col-md-4 offset-md-4 mb-3">Update Question</button>
                </div>
            </div>
        </form>
    </div>
</div>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

<!-- JavaScript/jQuery code -->
<script>
    $(document).ready(function () {
        var counter = 0;

        // Add Answer button click event
        $("#add-answer-button").on("click", function () {
            // Generate a unique ID for the new answer
            var answerId = "answer_" + counter++;

            // Load the partial view into the container
            $.get("/Admin/Topic/AddQuestionPartial", { answerId: answerId, isUpdate: true }, function (response) {
                $("#question-answers-container").append(response);
            });
        });
    });
</script>

src/TestYourSkills.Web/Areas/Admin/Views/Topic/UpdateTopic.cshtml
@model UpdateTopicViewModel

<div class="card-text shadow border-0 mt-4">
    <div class="card-header bg-primary ml-0 p-3">
        <div class="row">
            <div class="col-6 text-end">
                <h2 class="text-white py-2">@Model.Name</h2>
            </div>
            <div class="col-6 mt-3 text-end">
                <a asp-controller="Topic" asp-action="AddQuestion" asp-route-topicId="@Model.Id" asp-route-topicName="@Model.Name" class="btn btn-secondary">
                    <i class="bi bi-plus-lg"></i> New Question
                </a>
            </div>
        </div>
    </div>
    <div class="card-body p-3">
        <form asp-action="UpdateTopicTitle" method="post">
            <input asp-for="Id" hidden/>
            <div class="row">
                <div asp-validation-summary="ModelOnly" class="text-danger" role="alert"></div>
                <div class="form-floating col-md-11 mb-3">
                    <input asp-for="Name" class="form-control" aria-required="true"/>
                    <span asp-validation-for="Name" class="text-danger"></span>
                    <label class="ms-2">Topic title</label>
                </div>
                <div class="col-md-1 text-end">
                    <button type="submit" title="Save" class="btn btn-lg btn-primary">
                        <i class="fa fa-save p-2 d-flex text-center"></i>
                    </button>
                </div>
            </div>
        </form>
        
        <h4 class="divider-text d-flex py-3">Questions</h4>
        <form asp-action="UpdateQuestion" method="post">
            <div class="row">
                <div class="list-group ps-3">
                    <div class="accordion" id="accordionExample">
                        <div class="accordion-item">

                            @if (@Model.Questions != null)
                            {
                                foreach (var question in @Model.Questions)
                                {
                                    <div class="row">
                                        <h2 class="accordion-header col-md-10" id="headingOne">
                                            <button class="accordion-button collapsed border-bottom" type="button" data-bs-toggle="collapse" data-bs-target="#collapseOne-@question.Id" aria-expanded="false" aria-controls="collapseOne">
                                                @question.Title
                                            </button>
                                        </h2>

                                        <div class="col-md-1">
                                            <a asp-controller="Topic" asp-action="UpdateQuestion"
                                               asp-route-topicId="@Model.Id"
                                               asp-route-topicName="@Model.Name"
                                               asp-route-questionId="@question.Id"
                                               title="Edit" class="btn btn-lg btn-primary d-flex text-center ms-3">
                                                <i class="bi bi-pencil-square pb-1 px-2"></i>
                                            </a>
                                        </div>
                                        <div class="col-md-1">
                                            <a asp-controller="Topic" asp-action="DeleteQuestion"
                                               asp-route-topicId="@Model.Id"
                                               asp-route-topicName="@Model.Name"
                                               asp-route-questionId="@question.Id"
                                               title="Delete" class="btn btn-lg btn-primary d-flex text-center ms-3">
                                                <i class="bi bi-trash-fill"></i>
                                            </a>
                                        </div>

                                        <div id="collapseOne-@question.Id" class="accordion-collapse collapse" aria-labelledby="headingOne" data-bs-parent="#accordionExample">
                                            @if (question.QuestionAnswers != null)
                                            {
                                                if (question.Details != null)
                                                {
                                                    <h5 class="m-2">Has Details</h5>
                                                }

                                                foreach (var questionAnswer in question.QuestionAnswers)
                                                {
                                                    <div class="accordion-body form-floating col-md-11">
                                                        <input class="form-control bg-white" value="@questionAnswer.Message" disabled aria-required="true"/>
                                                        <label class="ms-2">
                                                            @if (questionAnswer.CorrectAnswer)
                                                            {
                                                                @Html.Raw("Correct answer")
                                                            }
                                                            else
                                                            {
                                                                @Html.Raw("Dump answer")
                                                            }
                                                        </label>
                                                    </div>
                                                }
                                            }
                                        </div>
                                    </div>
                                }
                            }
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>